//---------------------------------------------------------------------------
//
// (c)Copyright Spacesoft corp., 2004 All rights reserved.
//								 Hiro KITAYAMA
//
// link with wininet.lib
//
// Add [#pragma comment(lib, "wininet.lib")] and
//	   add [$(BCB)\lib\Psdk] to lib directories.
//

//---------------------------------------------------------------------------
#pragma hdrstop
#include <windows.h>
#include <wininet.h>
#include <stdio.h>
#include "ftp.h"
#pragma comment(lib, "wininet.lib")


//---------------------------------------------------------------------------
char szServer[256] = "";
DWORD dwType = FTP_TRANSFER_TYPE_BINARY ;
BOOL bActiveSession = FALSE ;
HINTERNET hOpen ;
HINTERNET hConnect ;
char PROMPT[256] = "remote>>" ;


//---------------------------------------------------------------------------
_tag_jumTbl jmpTbl[] =
{
	{ "OPEN",	ftpOpen, "....ftpTCg֐ڑ." 			},
	{ "CLOSE",	ftpClose, "...ftpTCg֐ڑؒf."		},
	{ "DIR",	ftpDir, ".....fBNg\."			},
	{ "DEL",	ftpDel, ".....t@C폜."				},
	{ "MD", 	ftpMd, "......fBNg쐬."			},
	{ "RD", 	ftpRd, "......fBNg폜."			},
	{ "CD", 	ftpCd, "......fBNgύX."			},
	{ "BIN",	ftpBin, ".....][hoCi."		},
	{ "ASCII",	ftpAscii, "...][heLXg."		},
	{ "GET",	ftpGet, ".....t@C_E[h."		},
	{ "PUT",	ftpPut, ".....t@CAbv[h."		},
	{ "TYPE",	ftpType, "....[gt@C\."		},
	{ "MODE",	ftpMode, "....Local/Remote[h؂ւ."	},
	{ "BYE",	ftpQuit, "....vOI."				},
	{ "QUIT",	ftpQuit, "....vOI."				},
	{ "EXIT",	ftpQuit, "....vOI."				},
	{ NULL, 	NULL, ""					}	// terminator
} ;


//---------------------------------------------------------------------------
//
// G[bZ[W̕\
//
void ErrorOut( DWORD dError, char* szCallFunc)
{
	fprintf( stderr,  "%s: %d\n ", szCallFunc, dError ) ;
}


//---------------------------------------------------------------------------
//
// ZbVJĂȂ
//
void sessionErr( void )
{
	fputs( "ZbV͊JĂ܂.\n", stdout ) ;
}


//---------------------------------------------------------------------------
//
// [J̃fBNgꗗ\
//
BOOL FtpEnumLocalDirectory( void )
{
	static HANDLE fileHandle ;
	WIN32_FIND_DATA findData ;

	fileHandle = FindFirstFile( "*.*", &findData );
	if( fileHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
			if( findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				fprintf( stdout, "\t<%s>\n", findData.cFileName ) ;
			else
				fprintf( stdout, "\t%s\n", findData.cFileName ) ;
		} while( FindNextFile( fileHandle, &findData ) ) ;
		return TRUE ;
	}
	return FALSE ;
}


//---------------------------------------------------------------------------
//
// [g̃fBNgꗗ\
//
void FtpEnumDirectory( void )
{
	WIN32_FIND_DATA pData ;
	HINTERNET hFind ;
	DWORD dError ;

	hFind = FtpFindFirstFile( hConnect, TEXT("*.*"), &pData, 0, 0) ;
	if( hFind == NULL)
	{
		if( GetLastError()	== ERROR_NO_MORE_FILES )
		{
			fputs( "This directory is empty!\n", stdout ) ;
			return ;
		} else {
			ErrorOut( GetLastError(), "FindFirsts" ) ;
			return ;
		}
	}

	if( pData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		fprintf( stdout, "\t<%s>\n", pData.cFileName ) ;
	else
		fprintf( stdout, "\t%s\n", pData.cFileName ) ;

	dError = NO_ERROR ;
	do
	{
		if( !InternetFindNextFile( hFind, &pData ) )
		{
			dError = GetLastError() ;
			if( dError == ERROR_NO_MORE_FILES )
				break ;
			else {
				ErrorOut( dError, "InternetFindNextFiles" ) ;
				return ;
			}
		}
		else
		{
			if( pData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				fprintf( stdout, "\t<%s>\n", pData.cFileName ) ;
			else
				fprintf( stdout, "\t%s\n", pData.cFileName ) ;
		}
	} while( TRUE ) ;

	if( !InternetCloseHandle( hFind ) )
		ErrorOut( GetLastError(), "InternetCloseHandles" ) ;

	return ;
}


//---------------------------------------------------------------------------
//
// zXgւ̐ڑs
//
BOOL Open( CHAR * szHost )
{
	char szUser[256], szPass[256], szBuffer[256] ;

	if( *szHost == 0 )
	{
		fputs( "OPENւ̓zXgw肵Ă.\n", stdout ) ;
		return FALSE ;
	}

	// [U
	fputs( "Enter user name:", stdout ) ;
	fgets( szBuffer, sizeof szBuffer, stdin ) ;
	sscanf( szBuffer, "%s", szUser ) ;

	// pX[h
	fputs( "Enter password:", stdout ) ;
	fgets( szBuffer, sizeof szBuffer, stdin ) ;
	sscanf( szBuffer, "%s", szPass ) ;

	// ڑ
	hConnect = InternetConnect( hOpen, szHost , INTERNET_DEFAULT_FTP_PORT,
				szUser,  szPass, INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE , 0) ;
	if( hConnect == NULL )
	{
		ErrorOut( GetLastError(), "InternetConnects" ) ;
		return FALSE ;
	}
	bActiveSession = TRUE ;
	lstrcpy( szServer, szHost ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// ftpT[oڑmainvV[W
//
BOOL ftpOpen( char* Host )
{
	if( bActiveSession )
	{
		fprintf( stdout, "ɐڑł<%s>.CloseĂ.\n", szServer ) ;
		return TRUE ;
	}

	if( Open( Host ) )
		fprintf( stdout, "<%s>֐ڑ܂.\n", Host ) ;
	else
		fputs( "ZbV܂.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// t@C̃Abv[hs܂
//
BOOL ftpPut( char* szFile )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !FtpPutFile( hConnect, szFile, szFile, dwType, 0 ) )
		ErrorOut( GetLastError(), "FtpPutFiles" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// t@C̃_E[hs܂
//
BOOL ftpGet( char* szFile )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

//	if( !FtpGetFile( hConnect, szFile, szFile, FILE_ATTRIBUTE_NORMAL,
//								dwType | FALSE,INTERNET_FLAG_RELOAD, 0 ) )
	if( !FtpGetFile( hConnect, szFile, szFile, FALSE, FILE_ATTRIBUTE_NORMAL,
								dwType | INTERNET_FLAG_RELOAD, 0 ) )
		ErrorOut( GetLastError(), "FtpGetFiles" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [g̃t@Ce\܂D
//
BOOL ftpType( char* szFile )
{
	DWORD lpdwNumberOfBytesRead ;
	char lpBuffer[4096] ;
	HINTERNET hFile ;
	BOOL bRead ;

	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	hFile = FtpOpenFile( hConnect, szFile, GENERIC_READ,	
									FTP_TRANSFER_TYPE_ASCII, 0 ) ;
	if( hFile == NULL )
	{
		ErrorOut( GetLastError(), "FtpOpenFiles" ) ;
		return TRUE ;
	}

	lpdwNumberOfBytesRead = 1 ;
	while( lpdwNumberOfBytesRead != 0 )
	{
		bRead = InternetReadFile( hFile, lpBuffer, sizeof	
									lpBuffer, &lpdwNumberOfBytesRead ) ;
		if( bRead != TRUE )
		{
			InternetCloseHandle( hFile ) ;
			ErrorOut( GetLastError(), "InternetReadFiles" ) ;
			return TRUE ;
		}
		fputs( lpBuffer, stdout ) ;
	}
	InternetCloseHandle( hFile ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[g̃t@C폜܂D
//
BOOL ftpDel( char* szFile )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !FtpDeleteFile( hConnect, szFile ) )
		ErrorOut( GetLastError(), "FtpDeleteFiles" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[J̃t@C폜܂D
//
BOOL ftpLDel( char* szFile )
{
	if( DeleteFile( szFile ) == 0 )
		ErrorOut( GetLastError(), "DeleteFiles" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[gɃfBNg쐬܂D
//
BOOL ftpMd( char* szDir )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !FtpCreateDirectory( hConnect, szDir ) )
		ErrorOut( GetLastError(), "FtpCreateDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[JɃfBNg쐬܂D
//
BOOL ftpLMd( char* szDir )
{
	if( CreateDirectory( szDir, NULL ) == 0 )
		ErrorOut( GetLastError(), "CreateDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[g̃fBNg폜܂D
//
BOOL ftpRd( char* szDir )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !FtpRemoveDirectory( hConnect, szDir ) )
		ErrorOut( GetLastError(), "FtpRemoveDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
//	[J̃fBNg폜܂D
//
BOOL ftpLRd( char* szDir )
{
	if( RemoveDirectory( szDir ) == 0 )
		ErrorOut( GetLastError(), "RemoveDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [g̃fBNgύX
//
BOOL ftpCd( char* szDir )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !FtpSetCurrentDirectory( hConnect, szDir ) )
		ErrorOut( GetLastError(), "FtpSetCurrentDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [J̃fBNgύX
//
BOOL ftpLCd( char* szDir )
{
	if( SetCurrentDirectory( szDir ) == 0 )
		ErrorOut( GetLastError(), "SetCurrentDirectorys" ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// ][hASCII
//
BOOL ftpAscii( char *szDummy )
{
	dwType = FTP_TRANSFER_TYPE_ASCII ;
	fputs( "][hASCIIɂ܂.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// ][hoCiւ
//
BOOL ftpBin( char *szDummy )
{
	dwType = FTP_TRANSFER_TYPE_BINARY ;
	fputs( "][hoCiɂ܂.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [g̃t@C\
//
BOOL ftpDir( char* szDummy )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	FtpEnumDirectory() ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [J̃t@C\
//
BOOL ftpLDir( char* szDummy )
{
	if( !FtpEnumLocalDirectory() )
		fputs( "[JfBNgɃt@C͂܂.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// Wve[ȕ
//
void chgTbl( _tag_jumTbl jmpTblLocal[] )
{
	int index, index1 ;

	index = 0 ;
	while( jmpTblLocal[index].szCmd != NULL )
	{

		index1 = 0 ;
		while( jmpTbl[index1].szCmd != NULL )
		{
			if( lstrcmp( jmpTblLocal[index].szCmd, jmpTbl[index1].szCmd ) == 0 )
			{
				jmpTbl[index1].pProcedure = jmpTblLocal[index].pProcedure ;
				break ;
			}
			index1++ ;
		}
		index++ ;
	}
}


//---------------------------------------------------------------------------
//
// [J[h
//
BOOL ftpLocal( void )
{
	_tag_jumTbl jmpTblLocal[] =
	{
		{ "DIR", ftpLDir, ""	},
		{ "DEL", ftpLDel, ""	},
		{ "MD",  ftpLMd,  ""	},
		{ "RD",  ftpLRd,  ""	},
		{ "CD",  ftpLCd,  ""	},
		{ NULL,  NULL,	  ""	}	// terminator
	} ;

	strcpy( PROMPT, "local>>" ) ;
	chgTbl( jmpTblLocal ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [g[h
//
BOOL ftpRemote( void )
{
	_tag_jumTbl jmpTblRemote[] =
	{
		{ "DIR", ftpDir, "" 	},
		{ "DEL", ftpDel, "" 	},
		{ "MD",  ftpMd,  "" 	},
		{ "RD",  ftpRd,  "" 	},
		{ "CD",  ftpCd,  "" 	},
		{ NULL,  NULL,	 "" 	}	// terminator
	} ;

	strcpy( PROMPT, "remote>>" ) ;
	chgTbl( jmpTblRemote ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// RlNV
//
BOOL ftpClose( char* szDummy )
{
	if( !bActiveSession )
	{
		sessionErr() ;
		return TRUE ;
	}

	if( !InternetCloseHandle( hConnect ) )
		ErrorOut( GetLastError(), "InternetCloseHandles" ) ;
	bActiveSession = FALSE ;

	fputs( "ZbV܂.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// [J̃fBNgύX
//
BOOL ftpMode( char* mode )
{
	if( lstrcmpi( mode, "LOCAL" ) == 0 )
		return ftpLocal() ;

	if( lstrcmpi( mode, "REMOTE" ) == 0 )
		return ftpRemote() ;

	fputs( "ɂLOCALREMOTEw肵Ă.\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// vOI
//
BOOL ftpQuit( char* szDummy )
{
	return FALSE ;
}


//---------------------------------------------------------------------------
//
//	parser routine
//
//	szCmd - ftp command
//	szOperand  - operand
//
//	Returns: TRUE  - continue.
//			 FALSE - quit
//
BOOL parser(char* szCmd, char* szOperand )
{
	int index ;

	strupr( szCmd ) ;

	index = 0 ;
	while( jmpTbl[index].szCmd != NULL )
	{
		if( lstrcmp( szCmd, jmpTbl[index].szCmd ) == 0 )
			return jmpTbl[index].pProcedure( szOperand ) ;
		index++ ;
	}

	fputs( "**********<< R}hEXg >>*************\n", stdout ) ;
	index = 0 ;
	while( jmpTbl[index].szCmd != NULL )
	{
		fprintf( stderr, "\t%s%s\n", jmpTbl[index].szCmd,jmpTbl[index].szHelp ) ;
		index++ ;
	}
	fputs( "************<< R}hEXgI >>*******\n", stdout ) ;

	return TRUE ;
}


//---------------------------------------------------------------------------
//
// C
//
#pragma argsused
int main(int argc, char* argv[])
{
	char szBuffer[256] ;
	char szArg1[256], szArg2[256] ;

	fputs( "WinInet FTP Tv NCAg vO\n", stdout  ) ;

	hOpen = InternetOpen( "SpacesoftFtp",  INTERNET_OPEN_TYPE_DIRECT , NULL, 0, 0) ;
	if( hOpen == NULL )
	{
		ErrorOut ( GetLastError(), "InternetOpens");
		return -1 ;
	}

	while( TRUE )
	{
		fputs( PROMPT, stdout ) ;
		strcpy( szArg1, "" ) ;
		strcpy( szArg2, "" ) ;
		fgets( szBuffer, sizeof szBuffer, stdin ) ;
		sscanf( szBuffer, "%s%s", szArg1, szArg2 ) ;

		if( parser( szArg1, szArg2 ) == FALSE )
			return -1 ;

	}
}
